Option Explicit
'On Error Resume Next

Dim Action
Dim Display
Dim Status
Dim dblValue1
Dim dblMemory
Dim FunctionFlag
Dim FunctionCommand
Dim SecondValueFlag
Dim IsFlag


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
dblValue1       = 0
dblMemory       = 0
Display         = "0"
FunctionFlag    = False
FunctionCommand = ""
SecondValueFlag = False
IsFlag          = False
	
SetPropertyValue "Calculator.Display", Display
SetPropertyValue "Calculator.Memory", ""

Do
	Sleep 1
	Action = GetPropertyValue ("Calculator.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Calculator.Action", "Waiting"
		Sleep 50
		If Action <> "" Then
			Call Handle_CalculatorAction(Action)
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "Calculator.Status", Status
			Status = ""
		End If
	End If
Loop


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_CalculatorAction(Action)
Dim Data

	Data = Split(Action, "^")
	Select Case Data(0)
		Case "Key"     : Call Process_Key(Data(1))
		Case "Function": Call Handle_Function(Data(1))
		Case "Memory"  : Call Handle_Memory(Data(1))
		Case "Clear"   : Call Handle_Clear(Data(1))
	End Select
	
	SetPropertyValue "Calculator.Display", Display
	
	If dblMemory <> 0 Then
		SetPropertyValue "Calculator.Memory", "M"
	Else
		SetPropertyValue "Calculator.Memory", ""
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Process_Key(Data)

	If IsNumeric(Display) = True Then
		If IsFlag = False Then 'Reset SecondValue (dblValue1) after = is carried out
			If FunctionFlag = True Then
				SecondValueFlag = True
				FunctionFlag    = False
				dblValue1       = CDbl(Display)
				Display         = "0"
			End If
		Else
			Call Handle_Clear("All")
		End If
		
		If Display = "0" Then
			If Data = "." Then
				Display = Display & Data
			Else
				Display = Data
			End If
		Else
			Display = Display & Data
		End If
	Else
		Display = "Press CE"
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_Function(Data)

	If IsNumeric(Display) = True Then
		FunctionFlag = True
		IsFlag       = False
		
		Select Case Data:
			Case "=":
				IsFlag = True
				
				If SecondValueFlag = False Then 'This enables functions like; 5 x = 25 or 3 + = 6
					SecondValueFlag = True
					dblValue1 = CDbl(Display)
				End If
				
				Select Case FunctionCommand
					Case "+":
						Display = CDbl(dblValue1) + CDbl(Display)
					Case "-":
						Display = CDbl(dblValue1) - CDbl(Display)
					Case "*":
						Display = CDbl(dblValue1) * CDbl(Display)
					Case "/":
						If CDbl(Display) <> 0 Then
							Display = CDbl(dblValue1) / CDbl(Display)
						Else
							Display = "Devide by zero"
						End If
				End Select
			Case "+/-":
				Display = CDbl(Display) * -1
			Case Else
				FunctionCommand = Data
		End Select
	Else
		Display = "Press CE"
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_Memory(Data)

	Select Case Data
		Case "Plus":
			dblMemory    = CDbl(dblMemory) + CDbl(Display)
			FunctionFlag = True 'Set to True so the next digit will be the first again
		Case "Set":
			dblMemory    = CDbl(Display)
			FunctionFlag = True
		Case "Recall":
			If FunctionFlag = True Then
				Call Process_Key(CDbl(dblMemory))
			Else
				Display = CDbl(dblMemory)
			End If
			FunctionFlag = True
		Case "Clear":
			dblMemory = 0
	End Select
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_Clear(Data)

	Select Case Data
		Case "Current":
			Display = "0"
		Case "All":
			dblValue1       = 0
			Display         = "0"
			FunctionFlag    = False
			FunctionCommand = ""
			SecondValueFlag = False
			IsFlag          = False
		Case "Last":
			If Len(Display) = 1 Or (Len(Display) = 2 And Left(Display, 1) = "-") Then
				Display = "0"
			Else
				Display = Left(Display, Len(Display) - 1)
			End If
		Case "Exit":
			dblValue1       = 0
			dblMemory       = 0
			Display         = "0"
			FunctionFlag    = False
			FunctionCommand = ""
	End Select
End Sub
